#!/usr/bin/env python
#
# Delete All Jobs
#
# 08/18/2010 HF Created
# 08/18/2011 HF Last Modified
#
# Delete All Jobs submiited by ManyJobs: DeleteAll.py [DB file] 
#
#
import os
import sys
import string
#
#
if (len(sys.argv) < 2):
    print "%s [ManyJOBS Data Base File\n" % (sys.argv[0])
#
# get ManyJOBS dir
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0]))
#
# Set Path and Import Modules
sys.path.append(ManyJobsDir+"/localbin")
import ManyJobsManager
import PauseList
import StatusDatabase
from submit_job import *
#
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
#
msg = "Finialize ManyJobs"
log_file(os.path.dirname(manyJobsDB),msg)
#
#
# init ManyJOBS manager
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
userssh = mjm.getSecureShell()
mjm.finalize()
#
# Get Job info
statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
[Rname,RjobID,Rstatus,tasks] = statusDB.getUnfinishedJobList()
statusDB.finalize()
#
# KILL JOBS
for i in range(len(Rname)):
    if (RjobID[i] != "NO_ID"):
        mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
        rhost = mjm.getClusterAddressByName(Rname[i])
        jobLauch = mjm.getJobSubmitLauncherByName(Rname[i])
        ent = jobLauch.split(".py")
        jobKill = ent[0] + "_del.py"
        command = '%s %s %s %s' % (userssh,rhost, jobKill, RjobID[i])
        ans = commands.getoutput(command)
        #print command
        msg = "Kill " + RjobID[i] +" on " + Rname[i] + " " + Rstatus[i]
        log_file(os.path.dirname(manyJobsDB),msg)
        #
        if (Rstatus[i] != 'Queued'):
            jobName = Rstatus[i]
            mjm.reportFinishedTask(jobName,'KILLED')
        mjm.finalize()
        #
        #
        # Report Job killed
        statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
        statusDB.reportJobToFinished(Rname[i],RjobID[i])
        statusDB.finalize()
        #
    else:
        print "Job-id on %s is unkown" % (name)
#
# record kill tasks
numOfTasks = len(tasks)
tStatus = []
for i in range(numOfTasks):
    tStatus.append('KILLED')
statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
statusDB.reportTasksToFinished(numOfTasks,tasks,tStatus)
statusDB.finalize()
#
#
msg = "************************************"
log_file(os.path.dirname(manyJobsDB),msg)
#
#
#

