#!/usr/bin/python
#
# Flush Pause List
#
# 08/02/2011 HF Created
#
import sys
import string
import os
import shutil
#
if (len(sys.argv) < 2):
    print "%s [ManyJOBS Data Base File\n" % (sys.argv[0])
#
# get ManyJOBS dir
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0])) + "/localbin"
#
# Set Path and Import Modules
sys.path.append(ManyJobsDir)
import ManyJobsManager
import PauseList
import StatusDatabase
from submit_job import *
#
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
# Resubmit to paused hosts
pList = PauseList.PauseList(manyJobsDB)
while True:
    pausedClusterName = pList.getPausedHost()
    if (pausedClusterName == None):
        #msg = "Pause Host List is Empty"
        #log_file(os.path.dirname(manyJobsDB),msg)
        break
    #
    # init ManyJOBS manager
    mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
    # get information for the cluster
    localhostName = mjm.getLocalHost()
    rhost = mjm.getClusterAddressByName(pausedClusterName)
    jabLaunch = mjm.getJobSubmitLauncherByName(pausedClusterName)
    msg = "Get %s from the paused host list." % (pausedClusterName)
    log_file(os.path.dirname(manyJobsDB),msg)
    #
    # finalize ManyJOBS manager
    mjm.finalize()
    #
    if (rhost == "None"):
        continue
    #
    #  submit a new job
    submitJob(pausedClusterName,rhost,jabLaunch,localhostName,ManyJobsDir,manyJobsDB)
    #
    #
    pList.finalize()
