#!/usr/bin/python
#
# Submit Many JOBS
#
# 11/09/2009 HF Created
# 06/01/2011 HF Last Modified
#
# Start ManyJobs: StartManyJobs.py [DB file] 
#
#
import os
import sys
import string
import shutil
#
if (len(sys.argv) < 2):
    print "%s [ManyJOBS Data Base File\n" % (sys.argv[0])
#
# get ManyJOBS dir
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0])) + "/localbin"
#
# Set Path and Import Modules
sys.path.append(ManyJobsDir)
import ManyJobsManager
import PauseList
import StatusDatabase
from submit_job import *
#
#
# get Hosts & Jobs Data Base File name
manyJobsDB = os.path.abspath(sys.argv[1])
#
# Copy XSLT file to working dir
shutil.copyfile(ManyJobsDir+"/MJstatus.xslt",
                os.path.dirname(manyJobsDB)+"/MJstatus.xslt")
#
# Initialize Status Database
statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
if (statusDB.File == 1):
    print "Detele ", statusDB.StatusDatabase," Before Submit\n"
    statusDB.finalize()
    sys.exit()
statusDB.finalize()
#
# Initialize Paused Hosts List
pList = PauseList.PauseList(manyJobsDB)
pList.initialize()
pList.finalize()
#
#
#
msg = "********** START MANY JOBS ***********"
log_file(os.path.dirname(manyJobsDB),msg)
msg = "Data Base File : " + sys.argv[1]
log_file(os.path.dirname(manyJobsDB),msg)
msg = "**************************************"
log_file(os.path.dirname(manyJobsDB),msg)
#
#
# init ManyJOBS manager
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
#
#
# Get Local Host
UserHostName = mjm.getLocalHost()
#
# get host information
name = []
rhost = []
maxJobNum = []
jobLanch = []
[name,rhost,jobLanch,maxJobNum] = mjm.getClusterList()
#
# get secure copy
userscp = mjm.getSecureCopy()
#
# get secure shell
userssh = mjm.getSecureShell()
#
# finalize ManyJOBS manager
mjm.finalize()
#
#
#
# Submit JOBS
for i in range(len(name)):
    # Create LOG dirctory on Remote Host
    remoteUsrPath = os.path.dirname(jobLanch[i])
    remoteLogPath = os.path.dirname(remoteUsrPath)+"/log"
    command = "%s %s mkdir -p %s" % (userssh,rhost[i],remoteLogPath)
    commands.getoutput(command)
    #
    for j in range(int(maxJobNum[i])):
        #
        # Submit Job
        submitJob(name[i],rhost[i],jobLanch[i],UserHostName,ManyJobsDir,manyJobsDB)
	time.sleep(1)
#
#
#
#
#
