#
#
# Paused Host List
#
# 08/11/2010 Hideki Fujioka
# 08/17/2010 Hideki Fujioka Modifiy
#
import os
import sys
import commands
import string
import time
from log_file import *
class PauseList:
    """ Paused Host List """
    def __init__(self,fileName):
        """ lock pause list and read it """
        self.pausedList = os.path.abspath(fileName) + ".pauseHostList"
        # Check lock file
        self.lockFile = self.pausedList + ".lock"
        while (True ==  os.path.isfile(self.lockFile)):
            time.sleep(1)
        # Create lock file
        command = '/bin/touch %s' % (self.lockFile)
        commands.getoutput(command)
        #
        #
        # Read List
        if (True ==  os.path.isfile(self.pausedList)):
            inp = open(self.pausedList,'r')
            hosts = inp.readlines()
            inp.close()
            self.pHosts = []
            for host in hosts:
                ent = host.split()
                self.pHosts.append(ent[0])
        else:
            self.pHosts = []
        #
    def finalize(self):
        """ update List and unlock """
        #
        # update List
        outp = open(self.pausedList,'wt')        
        for host in self.pHosts:
            outp.write(host)
            outp.write("\n")
        outp.close()
        #
        # Delete lock file
        command = '/bin/rm -f %s' % (self.lockFile)
        commands.getoutput(command)
        #
        #
    def initialize(self):
        """ initialize List  """
        self.pHosts = []
    #
    #
    def getPausedHost(self):
        """ returns paused cluster """
        if (len(self.pHosts) <= 0):
            return None
        else:
            host = self.pHosts[-1]
            del self.pHosts[-1]
        #
        ans = host.split()
        return ans[0]
    #
    #
    def addPausedHost(self,cname):
        """ add host to pause """
        na = cname.split()
        self.pHosts.append(na[0])
    #
    #
#       
#
#
#
