#!/usr/bin/env python
#
# task end; this runs on local machine
#
# input1: Cluster Name
# input2: Job Name
# input3: Job ID
# input4: Job Data Base File
#
# 08/08/2011 Created By Hidek Fujioka
# 08/15/2011 Modified By Hidek Fujioka
#
import sys
import string
import os
import commands
import time
#
import ManyJobsManager
import PauseList
import StatusDatabase
from log_file import *
from submit_job import *
#
#
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0]))
clusterName = sys.argv[1]
jobID = sys.argv[2]
manyJobsDB = sys.argv[3]
manyJobsStatFile = sys.argv[4]
#
#
# Get List of Tasks and Statuses
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
userssh = mjm.getSecureShell()
rhost = mjm.getClusterAddressByName(clusterName)
mjm.finalize()
#
command = '%s %s cat %s' % (userssh, rhost, manyJobsStatFile)
ans = commands.getoutput(command)
lines = ans.split('\n')
#
#
# report finished task to DB
mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
taskNames = []
statuses = []
numOfTasks = 0
for line in lines:
    entry = line.split('=')
    if (len(entry) == 2):
        mjm.reportFinishedTask(entry[0],entry[1])
        taskNames.append(entry[0])
        statuses.append(entry[1])
        numOfTasks += 1
mjm.finalize()
#
msg = "Finished %d on %s ID=%s" % (numOfTasks,clusterName,jobID)
log_file(os.path.dirname(manyJobsDB),msg)
#
# Report Task finished
statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
statusDB.reportTasksToFinished(numOfTasks,taskNames,statuses)
statusDB.finalize()
#
# Append jobs.log file
for i in range(numOfTasks):
    msg = "Finished %s on %s ID=%s STATUS=%s" % (taskNames[i],clusterName,jobID,statuses[i])
    log_file(os.path.dirname(manyJobsDB),msg)
#
#
    
