#!/usr/bin/env python
#
# finalize job; this runs on local machine
#
# input1: Cluster Name
# input2: Job ID
# input3: Data Base File
# input4: Number of Tasks done
# input5: Job Status 
#
# 08/05/2011 Created By Hideki Fujioka
# 08/15/2011 Modified By Hideki Fujioka
#
import sys
import string
import os
import commands
import time
#
import ManyJobsManager
import PauseList
import StatusDatabase
from log_file import *
from submit_job import *
from flushPausedHost import *
#
#
ManyJobsDir = os.path.dirname(os.path.abspath(sys.argv[0]))
clusterName = sys.argv[1]
jobID = sys.argv[2]
manyJobsDB = sys.argv[3]
numOfTasks = int(sys.argv[4])
manyJobsStat = sys.argv[5]
#
#
# Report Finished Job
statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
statusDB.reportJobToFinished(clusterName,jobID)
statusDB.finalize()
#
#
# Error Check
suspendedClusterName = 'None'
if (manyJobsStat == 'ERROR_MANYJOBS'):
    # Delete all jobs and finalize ManyJobs
    command = '%s/../DeleteAll.py %s' % (ManyJobsDir,manyJobsDB)
    ans = commands.getoutput(command)
    log_file(os.path.dirname(manyJobsDB),ans)    
    #
else:
    if (manyJobsStat == 'ERROR_CLUSTER'):
        # Stop using this cluster
        suspendedClusterName = clusterName
        msg = "%s is suspended" % (suspendedClusterName)
        log_file(os.path.dirname(manyJobsDB),msg)            
        
        # Kill running/queued jobs
        # Get Job info
        statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
        [Rname,RjobID,Rstatus,Rtask] = statusDB.getJobList()
        statusDB.finalize()
        for i in range(len(Rname)):
            if (Rname[i] == clusterName):
                mjm = ManyJobsManager.ManyJobsManager(manyJobsDB)
                rhost = mjm.getClusterAddressByName(Rname[i])
                jobLaunch = mjm.getJobSubmitLauncherByName(Rname[i])
                #
                ent = jobLaunch.split(".py")
                jobKill = ent[0] + "_del.py"
                command = '%s %s %s %s' % (gsissh, rhost, jobKill, RjobID[i])
                ans = commands.getoutput(command)
                #print command
                msg = "Kill " + RjobID[i] 
                msg += " on " + Rname[i] 
                msg += " " + Rstatus[i]
                log_file(os.path.dirname(manyJobsDB),msg)
                #
                if (Rstatus[i] == 'Active'):
                    mjm.reportFinishedTask(Rtask[i],'KILLED')
                #
                mjm.finalize()
                #
                # Report Task killed
                statusDB = StatusDatabase.StatusDatabase(manyJobsDB)
                if (Rstatus[i] != 'Active'):
                    statusDB.reportTaskToFinished(Rname[i],Rtask[i],'KILLED')
                #
                # Report Job killed
                statusDB.reportJobToFinished(Rname[i],RjobID[i])
                statusDB.finalize()
                #
        #
    else: # manyJobsStat != 'ERROR_CLUSTER'
        #  Job ends normally
        # Place this host on Pause List
        pList = PauseList.PauseList(manyJobsDB)
        pList.addPausedHost(clusterName)
        pList.finalize()        
        #
        #
    #
    # Flush Paused Host
    if (numOfTasks > 0):
        flushPausedHost(manyJobsDB,suspendedClusterName)
    #
#
