#
# Pull A Task
# Get Variables for Task
# 08/08/2011 Created by Hideki Fujioka
# 08/12/2011 Modified by Hideki Fujioka
#
import sys
import string
import os
import commands
import time
import subprocess
#
from log_file import *
from end_task_remote import *
#
def pull_task(jobID,numOfSubjobs,mimNumOfSubjobs):
    dirname = os.path.dirname(os.path.abspath(sys.argv[0]))
    remoteusrbinDir = os.path.dirname(dirname) + "/remoteusrbin"
    #
    clusterName = os.getenv('MANYJOBS_CLUSTER_NAME')
    masterHost = os.getenv('MANYJOBS_MASTER_HOST')
    masterDir = os.getenv('MANYJOBS_MASTER_DIR')
    scriptDir = os.getenv('MANYJOBS_SCRIPT_DIR')
    logDir = os.getenv('MANYJOBS_LOG_DIR')
    masterJobsDB = os.getenv('MANYJOBS_MASTER_JOBS_DB')
    mpi_run = os.getenv('MANYJOBS_MPI')
    headnode = os.getenv('MANYJOBS_HEADNODE')
    sshcommand = os.getenv('MANYJOBS_SSHCOMMAND')
    #
    #
    # GET A TASK
    commandToLocal = "ssh " + masterHost + " "
    commandToLocal += masterDir + "/assign_to_do.py "
    commandToLocal += clusterName + " "
    commandToLocal += jobID + " "
    commandToLocal += masterJobsDB + " "
    commandToLocal += str(numOfSubjobs) + " "
    commandToLocal += str(mimNumOfSubjobs)
    #
    commandToHeadNode = sshcommand + " " + headnode + " "
    commandToHeadNode +=  scriptDir + "/relay_agent.py "
    #
    command = commandToHeadNode + commandToLocal
    # log
    log_file(logDir,command)
    ans = commands.getoutput(command)
    # log
    log_file(logDir,ans)
    #
    #
    taskNames = []
    if (ans.find('None') == -1):
        #
        #
        lines = ans.split('\n')
        id = 0
        fileopenflag = False
        for line in lines:
            vari = line.split('=')        
            if (vari[0].strip() == "MANYJOBS_NUMBER_OF_TASKS"):
                numOfSubjobs = int(vari[1])
                continue
            #
            if (vari[0] == "MANYJOBS_TASK_NAME"):
                envFileName = logDir + '/' + jobID + "%04d.env" % (id)
                taskNames.append(vari[1].strip())
                outp = open(envFileName,'wt')                        
                # Set up Environmental Variables
                outp.write("MANYJOBS_TASK_NAME=%s\n" % (vari[1].strip()))
                outp.write("MANYJOBS_CLUSTER_NAME=%s\n" % (clusterName))
                outp.write("MANYJOBS_MASTER_HOST=%s\n" % (masterHost))
                outp.write("MANYJOBS_MASTER_DIR=%s\n" % (masterDir))
                outp.write("MANYJOBS_SCRIPT_DIR=%s\n" % (scriptDir))
                outp.write("MANYJOBS_LOG_DIR=%s\n" % (logDir))
                outp.write("MANYJOBS_MASTER_JOBS_DB=%s\n" % (masterJobsDB))
                outp.write("MANYJOBS_MPI=%s\n" % (mpi_run))
                outp.write("MANYJOBS_HEADNODE=%s\n" % (headnode))
                outp.write("MANYJOBS_SSHCOMMAND=%s\n" % (sshcommand))
                outp.write("MANYJOBS_BATCH=%s\n" % (os.getenv('MANYJOBS_BATCH')))
                outp.write("MANYJOBS_SCRATCHDIR=%s\n" % (os.getenv('MANYJOBS_SCRATCHDIR')))
                # ADD ENVIRONMENTAL VIRIABLES TO SEND TO SUBJOBS    
                fileopenflag = True    
                continue
            #
            if (vari[0].strip() == "MANYJOBS_TASK_ENV"):
                if (vari[1].strip() == "END"):
                    outp.close()
                    id += 1
                    fileopenflag = False
                    continue
            #
            #
            if (fileopenflag == True):
                outp.write(line+'\n')
        #
        numOfSubjobs = id
    else:
        numOfSubjobs = 0
    #
    return [numOfSubjobs, taskNames]


