#!/usr/bin/env python
#
# RUN SubJob
# 08/10/2011 Created by Hideki Fujioka
# 08/18/2011 Modified by Hideki Fujioka
#
import sys
import string
import os
import commands
import time
import subprocess
#
from log_file import *
from pull_task import *
from finalize_job_remote import *
#
dirname = os.path.dirname(os.path.abspath(sys.argv[0]))
remoteusrbinDir = os.path.dirname(dirname) + "/remoteusrbin"
logDir = sys.argv[1]
jobID = sys.argv[2]
myid = int(sys.argv[3])
#
#
# SETTING NODES FILE
nodeFile = logDir + '/' + jobID + "%04d.nod" % (myid)
os.environ["MANYJOBS_SUBJOB_NODEFILE"] = nodeFile
if (True ==  os.path.isfile(nodeFile)):
    inp = open(nodeFile)
    lines = inp.readlines()
    inp.close()
else:
    # file not found
    msg = nodeFile + " not found"
    log_file(logDir,msg)
    sys.exit(0)
#
numcpus = len(lines)
os.environ["MANYJOBS_SUBJOB_NUMPROC"] = str(numcpus)
#
# Set jobID
os.environ["MANYJOBS_JOBID"] = jobID
#
# Read Environmental Variable File
envFile = logDir + '/' + jobID + "%04d.env" % (myid)
if (True ==  os.path.isfile(envFile)):
    inp = open(envFile)
    lines = inp.readlines()
    inp.close()
else:
    # file not found
    msg = envFile + " not found"
    log_file(logDir,msg)
    sys.exit(0)
#
# set env
jobscript="myjobscript.sh"
for line in lines:
    print line.strip()
    vari = line.split('=')
    if (len(vari) == 2):
        os.environ[vari[0].strip()] = vari[1].strip()
        if (vari[0].strip() == "JOBSCRIPT"):
            jobscript = vari[1].strip()
        if (vari[0].strip() == "MANYJOBS_TASK_NAME"):
            taskName = vari[1].strip()
    #
#
#
######### HERE RUN USER JOB ############
command = "%s/%s" % (remoteusrbinDir,jobscript)
log_file(logDir,command)
proc = subprocess.Popen(command,
                        shell=True,
                        stdout=subprocess.PIPE,
                        stderr=subprocess.PIPE)
ans = proc.communicate()
#
# OUT
fn = nodeFile.split('.nod')[0] + '.std'
outp = open(fn,'wt') 
outp.write(ans[0])
outp.close()        
fn = nodeFile.split('.nod')[0] + '.err'
outp = open(fn,'wt') 
outp.write(ans[1])
outp.close()
#
stat = proc.poll()
msg = "stat=" + str(stat) + "\n"
log_file(logDir,msg)
#
#
# check status
ManyJobsStatus = 'None'
if (stat == 10):# error to stop depending tanks
    ManyJobsStatus = 'ERROR'
if (stat == 20):# error to stop using this cluster
    ManyJobsStatus = 'ERROR_CLUSTER'
if (stat == 30):# error to stop ManyJobs
    ManyJobsStatus = 'ERROR_MANYJOBS'
# none
#
#
# Print Status to stdout
msg = "MANYJOBS_STATUS=" + ManyJobsStatus
print msg

