#!/usr/bin/env python
#
# Submit a Job to TACC LONESTAR Cluster
#
# 03/30/2011 Hidek Fujioka
# 03/30/2011 Hidek Fujioka : last modified
#
import sys
import string
import os
import commands
import time
import subprocess
#
dirname = os.path.dirname(sys.argv[0])
#
remoteBinDir = os.path.dirname(dirname) + "/remotebin"
sys.path.append(remoteBinDir)
from log_file import *
#
logDir =  os.path.dirname(remoteBinDir) + "/log"
#
# batch job information
allocationName = "TG-MCB100111"
wallTime = "1:00:00"
nproc = "12way 48"
#nproc = "1way 12"
jobName = "MJ-" + os.path.basename(sys.argv[4])
queueName = "normal
#queueName = "serial"
email = "hidekin2549@hotmail.com"
job = remoteBinDir + "/job_launcher.sh"
#
# SETTING NUMBER OF SUBJOBS
os.putenv('MANYJOBS_NUMOFSUBJOBS','4')
os.putenv('MANYJOBS_MINNUMOFSUBJOBS','1')
#
#
command = "qsub -N %s " % (jobName) 
command += "-A %s " % (allocationName)
command += "-l h_rt=%s " % (wallTime)
command += "-pe %s " % (nproc)
command += "-q %s " % (queueName)
command += "-M %s " % (email)
command += "-m abe "
command += "-V "
command += "%s" % (job)
#
# log
log_file(logDir,command)
#
# set evironment variables
os.putenv('MANYJOBS_CLUSTER_NAME', sys.argv[1])
os.putenv('MANYJOBS_MASTER_HOST', sys.argv[2])
os.putenv('MANYJOBS_MASTER_DIR', sys.argv[3])
os.putenv('MANYJOBS_MASTER_JOBS_DB', sys.argv[4])
os.putenv('MANYJOBS_SCRIPT_DIR', remoteBinDir)
os.putenv('MANYJOBS_LOG_DIR', logDir)
os.putenv('MANYJOBS_MPI', 'mvapich')
os.putenv('MANYJOBS_BATCH', 'sge')
os.putenv('MANYJOBS_SCRATCHDIR', '/scratch/01201/hfujioka')
os.putenv('MANYJOBS_SSHCOMMAND', 'ssh') # ssh command works on computing nodes
#
HName = commands.getoutput("hostname")
os.putenv('MANYJOBS_HEADNODE', HName)
#print command
#
#
# SUBMIT A JOB TO PBS
os.chdir(logDir)
ans = subprocess.Popen(command,
                       shell=True,
                       stdout=subprocess.
                       PIPE,stderr=subprocess.PIPE)
stdval =ans.communicate()[0]
#
# find phrase of 'Your job #### submittedd'
jobid =''
entry = stdval.split()
for i in range(len(entry)):
    if ((entry[i] == 'Your') & (entry[i+1] == 'job')):
        jobid = entry[i+2]
        break
#        
print "************\n"
print "MANYJOBID=%s\n" % (jobid)
print "************\n"
#
#
# log
log_file(logDir,stdval)

