#!/usr/bin/env python
#
# Submit a Job to LONI LINUX Cluster
#
# 11/11/2009 Hidek Fujioka
# 05/09/2011 Hidek Fujioka : last modified
#
import sys
import string
import os
import commands
import time
import subprocess
#
dirname = os.path.dirname(sys.argv[0])
#
remoteBinDir = os.path.dirname(dirname) + "/remotebin"
sys.path.append(remoteBinDir)
from log_file import *
#
logDir =  os.path.dirname(remoteBinDir) + "/log"
#
#
#
# batch job information
allocationName = "loni_acinus02"
wallTime = "1:00:00"
nproc = "nodes=1:ppn=4"
jobName = "MJ-" + os.path.basename(sys.argv[4])
queueName = "workq"
email = "hidekin2549@hotmail.com"
job = remoteBinDir + "/job_launcher.sh"
#
# SETTING NUMBER OF SUBJOBS
os.putenv('MANYJOBS_NUMOFSUBJOBS','1')
os.putenv('MANYJOBS_MINNUMOFSUBJOBS','1')
#
#
command = "qsub -N %s " % (jobName) 
command += "-A %s " % (allocationName)
command += "-l walltime=%s " % (wallTime)
command += "-l %s " % (nproc)
command += "-q %s " % (queueName)
command += "-M %s " % (email)
command += "-m abe -k oe -V "
command += "%s" % (job)
#
# log
log_file(logDir,command)
#
# set evironment variables
os.putenv('MANYJOBS_CLUSTER_NAME', sys.argv[1])
os.putenv('MANYJOBS_MASTER_HOST', sys.argv[2])
os.putenv('MANYJOBS_MASTER_DIR', sys.argv[3])
os.putenv('MANYJOBS_MASTER_JOBS_DB', sys.argv[4])
os.putenv('MANYJOBS_SCRIPT_DIR', remoteBinDir)
os.putenv('MANYJOBS_LOG_DIR', logDir)
os.putenv('MANYJOBS_MPI', 'mvapich2')
os.putenv('MANYJOBS_BATCH', 'pbs')
os.putenv('MANYJOBS_SCRATCHDIR', '/work/fuji/')
os.putenv('MANYJOBS_SSHCOMMAND', 'ssh') # ssh command works on computing nodes
#
HName = commands.getoutput("hostname")
os.putenv('MANYJOBS_HEADNODE', HName)
#
#
# SUBMIT A JOB TO PBS
os.chdir(logDir)
ans = subprocess.Popen(command,
                       shell=True,
                       stdout=subprocess.
                       PIPE,stderr=subprocess.PIPE)
stdval = ans.communicate()[0]
print "************\n"
print "MANYJOBID=%s\n" % (stdval.replace('\n',''))
print "************\n"
#
#
# log
log_file(logDir,stdval)
